Subject: Re: Parameters in Local Control

From: "Rosen, Brian" <[email-masked]>
Date: Fri, 14 Jul 2000 09:22:30 -0400

G'Day Christian

I do understand how we originally decided on the behavior of
repeating values, but I believe that the way the protocol has
evolved, the assumptions made are no longer valid, and we have
changed the way we use LocalControl and TerminationState.  The
way we created all the current packages, and the way we
construct examples, we are not using the "repeat all values"
paradigm.  We are using the "change it when you need to change
it" paradigm.

I'm not sure what package you refer to in your first example.
Modems have their own descriptor, which we are not (yet)
discussing in this thread, and I'm not aware of a package that
handles modems yet.

The second example, Echo Control, could refer to the TDM package
Annex E, section 13.  There is no description of having the first
setting of 'ec' put echo cancellation on line, or lack of it
putting echo cancel off line, and I would say that if that is
your interpretation, you need to verify your assumptions with others,
and we need to change the document to reflect it.

Being really carefull here, in general, there is no way to
MODIFY local and remote except by replacement -- that is, if you
send a modified SDP it does replace the prior value completely, and
I would expect that Annex B equivalents would behave the same way.
Generally speaking, because both ends of the flow have to change,
this is appropriate.

Termination State, however, should behave like LocalControl.

Brian

> -----Original Message-----
> From: Christian Groves [mailto:[email-masked]]
> Sent: Friday, July 14, 2000 8:54 AM
> To: Rosen, Brian
> Cc: [email-masked]
> Subject: Re: Parameters in Local Control
>
>
> G'Day Brian,
>
> I'm a little confused by this. In Megaco we settled on the following
> behaviour:
> "A new setting of a Local or Remote Descriptor completely replaces the
> previous setting of that descriptor in the MG.  Thus to retain
> information from the previous setting the MGC must include that
> information in the new setting.  If the MGC wishes to delete some
> information from the existing descriptor, it merely resends the
> descriptor (in a Modify command) with the unwanted
> information stripped
> out."
>
> I believe that properties=values are applicable for local and
> remote. So
> to date we do assume that you have to repeat old values. The issue is
> that we need to be able to remove a property after we have set it to a
> value otherwise in every single property we need a value to turn the
> property off.
>
> For example:
> You have a stream with media flowing.
> If you audited_value then no modem would appear.
> You then put a modem property on a line.
> If you audited_value then a modem property would appear.,
> You then turn the modem property off because you want to remove it
> (remove the associated physical resource from the stream).
> Do an audit and it still appears. I thought that you wouldn't want to
> see anything as you removed the modem.
>
> Another example:
> You have a stream with media flowing but with no reference to an echo
> canceller.
> You add the echo canceller property and turn it ON.
> You turn the echo canceller OFF but you still want it inlinked in the
> call but not operating, turning the property to off would allow this
> behaviour.
> You then want to outlink the echo canceller. Removing the
> property would
> allow this.
>
> So I believe you need to be able to:
> o Assign a property a value.
> o Turn this property off.
> o Remove this property.
> I don't think we should start playing with this behaviour now.
>
> Cheers, Christian
>
> PS: I'll be on holiday for a week so I probably won't get a chance to
> reply in a hurry
> "Rosen, Brian" wrote:
> >
> > If the ONLY thing you can put in a descriptor is
> > a property=value construct, then I think you don't need,
> > and don't want to have to, repeat values.  That would apply
> > to local and remote too.
> >
> > All of our examples, to date, do not assume that you have
> > to repeat old values.
> >
> > I don't think there is any concept of "deleting" properties.
> > What kind of properties were you thinking of?
> >
> > Brian
> >
> > > -----Original Message-----
> > > From: Christian Groves [mailto:[email-masked]]
> > > Sent: Wednesday, July 12, 2000 5:01 AM
> > > To: Rosen, Brian
> > > Cc: [email-masked]
> > > Subject: Re: Parameters in Local Control
> > >
> > >
> > > G'Day Brian,
> > >
> > > Why would we have a distinction in behaviour between
> Local Control,
> > > Local and Remote? They will all have property=value
> > > constructs and have
> > > properties defined by packages. We also have a concept to "delete"
> > > properties which needs to be maintained for Local Control.
> > >
> > > I wasn't particularly keen on having to re-send properties to
> > > keep them
> > > but that's what we decided to do so I feel that to be
> consistent in
> > > behaviour that we should keep things as is.
> > >
> > > Cheers, Christian
> > >
> > > "Rosen, Brian" wrote:
> > > >
> > > > In the text, section 7.1.7, it states:
> > > > A new setting of the LocalControl Descriptor completely
> replaces the
> > > >    previous setting of that descriptor in the MG.  Thus
> to retain
> > > >    information from the previous setting the MGC must
> include that
> > > >    information in the new setting.  If the MGC wishes
> to delete some
> > > >    information from the existing descriptor, it merely
> resends the
> > > >    descriptor (in a Modify command) with the unwanted
> information
> > > >    stripped out.
> > > >
> > > > Suppose you implemented a couple packages that defined
> a dozen or
> > > > so properties.  Do you have to repeat the values of
> each of these
> > > > properties in every modify of LocalControl?
> > > >
> > > > I think this paragraph is a remnant of an earlier
> concept, and with
> > > > LocalControl defined as it is now, this statement is in
> error, and
> > > > the actual desired behavior is that values are kept
> until modified.
> > > > Consider that LocalControl presently has only the Mode property,
> > > > the ReserveGroup and ReserveValue properties and properties of
> > > > a termination.
> > > > This means there is nothing in LocalControl that is not
> a property
> > > > with a value (as opposed to, say a flag).  Thus keeping
> old values
> > > > is very feasible, and I believe, what is desired.
> > > >
> > > > Brian
> > >
> > >
>